recursive subroutine MPI_Main
  implicit none
  include 'mpif.h'

  integer :: thisIndex, ierr, nblocks, i
  double precision :: inval, outval, expect

  call MPI_Init(ierr)
  call MPI_Comm_rank(MPI_COMM_WORLD, thisIndex, ierr)
  call MPI_Comm_size(MPI_COMM_WORLD, nblocks, ierr)

  inval = thisIndex + 1
  call MPI_Reduce(inval, outval, 1, MPI_DOUBLE_PRECISION, MPI_SUM, &
&                     0, MPI_COMM_WORLD, ierr)

  expect = (nblocks*(nblocks+1))/2
  if(thisIndex .eq. 0) then
    if (outval .eq. expect) then
      call MPI_Print('reduce test passed')
    else
      call MPI_Print('reduce test failed')
    end if
  end if
  call MPI_Finalize(ierr)

end subroutine
